package de.mbutscher.wikiandpad;

import de.mbutscher.wikiandpad.alphabeta.R;
import android.os.Bundle;
import android.preference.Preference;
import android.preference.Preference.OnPreferenceChangeListener;
import android.preference.PreferenceActivity;

public class Preferences extends PreferenceActivity {

    // Based on http://stackoverflow.com/questions/3206765/number-preferences-in-preference-activity-in-android
    OnPreferenceChangeListener nonNegNumberCheckListener = new
            OnPreferenceChangeListener() {

        public boolean onPreferenceChange(Preference preference,
                Object newValue) {
            try {
                int n = Integer.parseInt((String) newValue);
                return n >= 0;
            }
            catch (NumberFormatException e) {
                return false;
            }
        }
    };
    
    
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        getPreferenceManager().setSharedPreferencesMode(MODE_PRIVATE);
        getPreferenceManager().setSharedPreferencesName("wikidpad");
        addPreferencesFromResource(R.xml.preference_main);
        
        getPreferenceScreen().findPreference("clipboardCatcher_pollDelay")
                .setOnPreferenceChangeListener(nonNegNumberCheckListener);

        getPreferenceScreen().findPreference("snippetCollector_maxSnippets")
                .setOnPreferenceChangeListener(nonNegNumberCheckListener);
        
    }

}
