package de.mbutscher.wikiandpad;

import de.mbutscher.wikiandpad.alphabeta.R;
import de.mbutscher.wikiandpad.utils.ui.ActivityGuiHelper;
import android.app.Activity;
import android.content.Intent;
import android.content.Intent.ShortcutIconResource;
import android.os.Bundle;

public class ShortcutActivity extends Activity {

    protected ActivityGuiHelper<ShortcutActivity> guiHelper;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        guiHelper = new ActivityGuiHelper<ShortcutActivity>(this);
        
        setContentView(R.layout.shortcut_activity);
        
        guiHelper.setOnClickListener(R.id.btnShortcutToSnippetList,
                "onCmdShortcutToSnippetList");
    }
    
    
    public void onCmdShortcutToSnippetList() {
        ShortcutIconResource icon = Intent.ShortcutIconResource.fromContext(
                this, R.drawable.icon);

        Intent intent = new Intent();

        Intent launchIntent = new Intent(this, SnippetListActivity.class);
        launchIntent.setAction(Intent.ACTION_MAIN);

        /*
        Intent launchIntent = new Intent();
        launchIntent.setComponent(new ComponentName("de.mbutscher.wikiandpad",
                "SnippetListActivity"));
        */

        intent.putExtra(Intent.EXTRA_SHORTCUT_INTENT, launchIntent);
        intent.putExtra(Intent.EXTRA_SHORTCUT_NAME, "SnippetList");
        intent.putExtra(Intent.EXTRA_SHORTCUT_ICON_RESOURCE, icon);

        setResult(RESULT_OK, intent);
        finish();
    }
    
    
        
        
    
}
