package de.mbutscher.wikiandpad;

import java.util.ArrayList;
import java.util.List;

import de.mbutscher.wikiandpad.utils.StringOps;
import android.app.Activity;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
import android.os.Bundle;
import android.widget.Toast;

public class SnippetReceiverActivity extends Activity {
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        // setContentView(R.layout.data_receiver);
        
        Intent intent = getIntent();
        
        String text = intent.getStringExtra(Intent.EXTRA_TEXT);
        
        if (StringOps.notEmpty(text)) {
            SharedPreferences pref = WikiAndPadApplication.getAppPrefs();
            String snippetStr = pref.getString("snippetCollector_snippets", null);
            List<String> snippetList;
            if (StringOps.notEmpty(snippetStr))
                snippetList = StringOps.strToStrList(snippetStr);
            else
                snippetList = new ArrayList<String>();
            
            snippetList.add(text);
            
            int maxSnippets = Integer.parseInt(pref.getString(
                    "snippetCollector_maxSnippets", "30"));

            if ((maxSnippets > 0) && snippetList.size() > maxSnippets) {
                snippetList = snippetList.subList(
                        snippetList.size() - maxSnippets, snippetList.size());
            }
            
            Editor editor = pref.edit();
            editor.putString("snippetCollector_snippets",
                    StringOps.strListToStr(snippetList));
            editor.commit();
            
            Toast.makeText(this,
                    String.format("Snippet saved"),
                    Toast.LENGTH_SHORT).show();
        }
        else {
            Toast.makeText(this,
                    String.format("No data"),
                    Toast.LENGTH_SHORT).show();            
        }
        
        finish();
        
        
    }

}
