package de.mbutscher.wikiandpad;

import java.util.List;

import android.text.Spannable;


/**
 * Store parameters for
 * {@link android.text.Spannable#setSpan(Object, int, int, int)}
 * @author Michael Butscher
 *
 */
public class SpanEntry {
    public Object object;
    public int start;
    public int end;
    public int flags;


    public SpanEntry(Object object, int start, int end, int flags) {
        super();
        this.object = object;
        this.start = start;
        this.end = end;
        this.flags = flags;
    }
    
    public void applyTo(Spannable spannable) {
        spannable.setSpan(object, start, end, flags);
    }
    
    public static void applyList(List<SpanEntry> spanList,
            Spannable spannable) {
        
        if (spanList == null)
            return;

        for (SpanEntry entry: spanList) {
            entry.applyTo(spannable);
        }
    }
}
