package de.mbutscher.wikiandpad;

import java.io.FileOutputStream;
import java.io.PrintStream;
import java.lang.Thread.UncaughtExceptionHandler;

import android.content.Context;
import android.util.Log;

public class TheExceptionHandler implements Thread.UncaughtExceptionHandler {

    private volatile boolean m_crashing = false;
 
    @SuppressWarnings("unused")
    private final Context m_context;

    private UncaughtExceptionHandler origExHandler;
 
    
    public TheExceptionHandler(Context context,
            Thread.UncaughtExceptionHandler origExHandler) {
         m_context = context;
         this.origExHandler = origExHandler;
    }
    
    
    public static void logException(Throwable ex) {
        try {
            PrintStream ps = new PrintStream(new FileOutputStream(
                    "/sdcard/WikidPadError.log", true));
            ex.printStackTrace(ps);
            ps.print("/n/n");
            ps.close();
        } catch(Throwable t) {
            // Catch any Throwable as this would be fatal and cause infinite loops
            try {
                Log.e("TheExceptionHandler",
                        "Unexpected error in TheExceptionHandler!", t);
            } catch (Throwable t2) {
            }
        }
        
    }
    
    public void uncaughtException(Thread thread, Throwable ex) {
        try {
            // Only report a crash once
            if(m_crashing) return;
            m_crashing = true;
            
            logException(ex);
            if (origExHandler != null)
                origExHandler.uncaughtException(thread, ex);
            
         } catch(Throwable t) {
            // Catch any Throwable as this would be fatal and cause infinite loops
            try {
                Log.e("TheExceptionHandler",
                        "Unexpected error in TheExceptionHandler!", t);
            } catch (Throwable t2) {
            }
        } finally {
            /*android.os.Process.killProcess(android.os.Process.myPid());
            System.exit(10);*/
        }
    }

}
