package de.mbutscher.wikiandpad;


/**
 * Used by {@link WikiConfig#testOptionAllowed(String)}
 * @author Michael Butscher
 *
 */
@SuppressWarnings("serial")
public class UnknownOptionException extends RuntimeException {

    public UnknownOptionException() {
        super();
    }

    public UnknownOptionException(String detailMessage, Throwable throwable) {
        super(detailMessage, throwable);
    }

    public UnknownOptionException(String detailMessage) {
        super(detailMessage);
    }
    
    public UnknownOptionException(String formatMessage, String... args) {
        super(String.format(formatMessage, (Object[]) args));
    }
    
    public UnknownOptionException(Throwable throwable) {
        super(throwable);
    }
}
