package de.mbutscher.wikiandpad;

import de.mbutscher.wikiandpad.alphabeta.R;
import de.mbutscher.wikiandpad.utils.MiscEvent;
import de.mbutscher.wikiandpad.utils.MiscEventListener;
import android.content.ComponentName;
import android.content.Intent;
import android.os.Bundle;
import android.support.v4.app.FragmentActivity;

public class WikiWordListActivity extends FragmentActivity
        implements MiscEventListener {

    protected WikiWordListFragment wikiWordListFragment;
    
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        setContentView(R.layout.container_wiki_word_list);
        
        wikiWordListFragment = (WikiWordListFragment)
                getSupportFragmentManager().findFragmentById(
                        R.id.frgWikiPageList);

        /*
        if (savedInstanceState == null) {
            getSupportFragmentManager().beginTransaction().add(
                    android.R.id.content,
                    new WikiWordListFragment(), "WikiWordListFragment").commit();
        }
        */
    }

    public void miscEventHappened(MiscEvent event) {
        if (event.hasKey("request openWikiWord")) {
            Intent intent = new Intent(Intent.ACTION_EDIT);
            intent.setComponent(new ComponentName(this,
                    WikiWordEditActivity.class));
            intent.putExtra("wikiConfigPath", (String) event.getValue(
                    "wikiConfigPath"));
            intent.putExtra("wikiPageName", (String) event.getValue(
                    "wikiPageName"));
            
            startActivity(intent);
        }
        
        else if (event.getSource() == wikiWordListFragment) {
            if (event.hasKey("request finish"))
                finish();
        }
    }

    @Override
    protected void onPause() {
        super.onPause();
        MiscEvent.removeListener(wikiWordListFragment, this);
    }

    @Override
    protected void onResume() {
        super.onResume();
        MiscEvent.addListener(wikiWordListFragment, this);
    }

    /*
    public boolean onCreateOptionsMenu(Menu menu) {
        MenuInflater inflater = getMenuInflater();
        inflater.inflate(R.menu.wiki_word_list, menu);
        return true;
    }
    
    public boolean onPrepareOptionsMenu (Menu menu) {
        MenuItem item = menu.findItem(R.id.mnCloseWiki);
        item.setVisible(WikiDocument.getActiveDocument() != null);

        item = menu.findItem(R.id.mnSearch);
        item.setVisible(WikiDocument.getActiveDocument() != null);

        return true;
    }
    
    public boolean onOptionsItemSelected(MenuItem item) {
        Intent intent;

        switch (item.getItemId()) {
        case R.id.mnOpenWiki:
            FolderPicker mFileDialog = new FolderPicker(
                    WikiWordListActivity.this, onOpenWiki,
                    android.R.style.Theme, true);
            mFileDialog.show();

            return true;
        case R.id.mnCloseWiki:
            try {
                WikiDocument.openDocument(null, true);
            }
            catch (FileNotFoundException e) {}
            catch (IOException e) {}
            catch (WikiDataException e) {}

            updateShowHideUi();
            updateList();
            return true;
        case R.id.mnPreferences:
            intent = new Intent(getBaseContext(), Preferences.class);
            startActivity(intent);
            
            return false;
        case R.id.mnSearch:
            onSearchRequested();
            
            return false;
        case R.id.mnAbout:
            intent = new Intent(Intent.ACTION_VIEW);
            intent.setComponent(new ComponentName(this,
                    AboutActivity.class));

            startActivity(intent);
            
            return false;
        default:
            return super.onOptionsItemSelected(item);
        }
    }
    

    @Override
    public void onCreateContextMenu(ContextMenu menu, View v,
            ContextMenuInfo menuInfo) {
        super.onCreateContextMenu(menu, v, menuInfo);
        if (v == getListView()) {
            MenuInflater inflater = getMenuInflater();
            inflater.inflate(R.menu.wiki_word_listitem_context, menu);
        }
    }

    @Override
    public boolean onContextItemSelected(MenuItem item) {
        AdapterContextMenuInfo info =
                (AdapterContextMenuInfo) item.getMenuInfo();
        MatchTermEntry mte;
        switch (item.getItemId()) {
        case R.id.mnRenameThis:
            mte = listContent.get(info.position);
            if (WikiDocument.getActiveDocument().getWikiName().equals(
                    mte.wikiPageName)) {
                Toast.makeText(this, "Rename of root page not supported",
                        Toast.LENGTH_SHORT).show();
            }
            else {
                onRename(mte.wikiPageName);
            }

        case R.id.mnDeleteThis:
            mte = listContent.get(info.position);
            if (WikiDocument.getActiveDocument().getWikiName().equals(
                    mte.wikiPageName)) {
                Toast.makeText(this, "Delete of root page not possible",
                        Toast.LENGTH_SHORT).show();
            }
            else {
                onDelete(mte.wikiPageName);
            }

            return false;
        default:
            return super.onContextItemSelected(item);
        }
    }
    
        */

}
