package de.mbutscher.wikiandpad.parsing;

import java.util.List;

/**
 * Returned by parse() methods.
 * All member variables can be accessed directly.
 * 
 * @author Michael Butscher
 *
 */
public class ParsingResult extends BaseParsingProduct {
    public int nextLoc;

    public ParsingResult(int nextLoc, List<SyntaxNode> retTokens) {
        super(retTokens);
        this.nextLoc = nextLoc;
    }
    
    public ParsingResult(int nextLoc, SyntaxNode syntaxNode) {
        super(syntaxNode);
        this.nextLoc = nextLoc;
    }

    /**
     * Necessary to resolve ambiguity because NonTerminalNode implements
     * List&lt;SyntaxNode&gt;
     */
    public ParsingResult(int nextLoc, NonTerminalNode syntaxNode) {
        this(nextLoc, (SyntaxNode) syntaxNode);
    }
    
    
    public ParsingResult(int nextLoc) {
        this(nextLoc, EMPTYLIST);
    }

    public ParsingResult() {
        this(-1, EMPTYLIST);
    }

    /*
    public ParsingResult(List<SyntaxNode> retTokens) {
        this(-1, retTokens);
    }

    public ParsingResult(SyntaxNode syntaxNode) {
        this(-1, syntaxNode);
    }
    */

}
