package de.mbutscher.wikiandpad.parsing;

import java.util.Map;
import java.util.Stack;

import de.mbutscher.wikiandpad.utils.ThreadStop;

/**
 *  State object handed to action callbacks with additional information
 *  about the parsing state.
 *  All member variables can be accessed directly.
 * @author Michael Butscher
 *
 */
public class ParsingState {
    public Stack<String> nameStack;
    public StackedDict<String, Object> dictStack;
    public ThreadStop threadstop;
    public String fullText;
    public String revText;
    
    public ParsingState(String fullText, Map<String, Object> baseDict,
            ThreadStop threadstop) {
        nameStack = new Stack<String>();
        dictStack = new StackedCopyDict<String, Object>(baseDict);
        
        if (threadstop == null)
            this.threadstop = ThreadStop.DUMBTHREADSTOP;
        else
            this.threadstop = threadstop;
        
        this.fullText = fullText;
        
        StringBuilder toRev = new StringBuilder(fullText);
        toRev.reverse();
        revText = toRev.toString();
    }
}
